## dpkg 1.22.21

=== tests/t-dir-shared-replaces-lost/Makefile ===
TESTS_DEB := pkg-dir-original pkg-dir-takeover

include ../Test.mk

TEST_CASES += test-ordered
TEST_CASES += test-reverse

test-case: $(TEST_CASES)

define VERIFY
$(call pkg_is_installed,pkg-dir-original)
$(call pkg_is_installed,pkg-dir-takeover)
test -d '$(DPKG_INSTDIR)/test-dir'
test "`$(DPKG_QUERY) -S /test-dir/test-original`" = "pkg-dir-original: /test-dir/test-original"
test "`$(DPKG_QUERY) -S /test-dir/test-takeover`" = "pkg-dir-takeover: /test-dir/test-takeover"
endef

test-ordered:
	# test-ordered
	$(DPKG_INSTALL) pkg-dir-original.deb
	$(BEROOT) rm -rf '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_INSTALL) pkg-dir-takeover.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-dir-original pkg-dir-takeover

test-reverse:
	# test-reverse
	$(DPKG_INSTALL) pkg-dir-takeover.deb
	$(BEROOT) rm -rf '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_INSTALL) pkg-dir-original.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-dir-original pkg-dir-takeover

test-clean:
	-$(DPKG_PURGE) pkg-dir-original pkg-dir-takeover

=== debian/changelog ===
dpkg (1.22.21) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Fix cleanup for control member with restricted directories.
    Fixes CVE-2025-6297. Reported by zhutyra on HackerOne.
  * Perl modules:
    - Dpkg::BuildDriver::DebianRules: Fix uninitialized Perl variables.
      Closes: #1107971
    - Dpkg::BuildDriver::DebianRules: Fix R³ dpkg/target/<target> values
      handling.
    - Dpkg::BuildTree: Fix needs_root() for R³ with implementation specific
      keywords. See #1107971.
  * Code internals:
    - libdpkg: Do not segfault when adding triggers in no-act mode.
      Closes: #1108192

 -- Guillem Jover <guillem@debian.org>  Tue, 01 Jul 2025 01:32:04 +0200

=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13.10~),
 pkgconf,
# Version needed for ITS support.
 gettext (>= 0.19.7),
# Version needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 libmd-dev,
 zlib1g-dev,
 libbz2-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210),
# Needed for the functional test.
 bzip2 <!nocheck>,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0) <!nocheck>,
# Needed for the functional test.
 zstd <!nocheck>,
# Needed for the author release process.
 git <pkg.dpkg.author-release>,
 ca-certificates <pkg.dpkg.author-release>,
 libmodule-build-perl <pkg.dpkg.author-release>,
# Needed for the test suite in author mode.
 fakeroot <pkg.dpkg.author-testing>,
 sq <pkg.dpkg.author-testing>,
 sqv (>= 1.3.0~) <pkg.dpkg.author-testing>,
 sqop <pkg.dpkg.author-testing>,
 sqopv <pkg.dpkg.author-testing>,
 rsop <pkg.dpkg.author-testing>,
 rsopv <pkg.dpkg.author-testing>,
 gosop <pkg.dpkg.author-testing>,
 gpg-sq <pkg.dpkg.author-testing>,
 gpgv-sq <pkg.dpkg.author-testing>,
 gnupg <pkg.dpkg.author-testing>,
 cppcheck <pkg.dpkg.author-testing>,
 shellcheck <pkg.dpkg.author-testing>,
 aspell <pkg.dpkg.author-testing>,
 aspell-en <pkg.dpkg.author-testing>,
 codespell <pkg.dpkg.author-testing>,
 i18nspector <pkg.dpkg.author-testing>,
 libtest-minimumversion-perl <pkg.dpkg.author-testing>,
 libtest-perl-critic-perl <pkg.dpkg.author-testing>,
 libtest-pod-coverage-perl <pkg.dpkg.author-testing>,
 libtest-pod-perl <pkg.dpkg.author-testing>,
 libtest-spelling-perl <pkg.dpkg.author-testing>,
 libtest-strict-perl <pkg.dpkg.author-testing>,
 libtest-synopsis-perl <pkg.dpkg.author-testing>,
# Needed for code coverage reports.
 lcov <pkg.dpkg.code-coverage>,
 libdevel-cover-perl <pkg.dpkg.code-coverage>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Version needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libmd-dev,
 zlib1g-dev,
# Version needed for multi-threaded decompressor support.
 liblzma-dev (>= 5.4.0),
# Version needed for the new streaming API.
 libzstd-dev (>= 1.4.0),
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Version needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
# Version needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
# OpenPGP implementations providing full support.
 sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq | gnupg,
# OpenPGP implementations providing at least verification-only support.
 sqv | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq | gpgv,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
 debian-tag2upload-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.40.0~),
# Uses new sqv features, w/o requiring a hard dependency on sqv.
 sqv (<< 1.3.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on rsop.
 rsop (<< 0.4.0~),
# Uses required SOP features, w/o requiring a hard dependency on gosop.
 gosop (<< 1.1.0~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Provides:
 dpkg-build-api (= 0),
 dpkg-build-api (= 1),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Version needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
# Version needed for multi-threaded decompressor support.
 xz-utils (>= 5.4.0),
Suggests:
 debian-keyring,
 debian-tag2upload-keyring,
# OpenPGP implementations providing full support.
 sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq | gnupg,
# OpenPGP implementations providing at least verification-only support.
 sqv | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq | gpgv,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
# Uses new sq features, w/o requiring a hard dependency on sq.
 sq (<< 0.40.0~),
# Uses new sqv features, w/o requiring a hard dependency on sqv.
 sqv (<< 1.3.0~),
# Uses required SOP features, w/o requiring a hard dependency on sqop.
 sqop (<< 0.27.2~),
# Uses required SOP features, w/o requiring a hard dependency on rsop.
 rsop (<< 0.4.0~),
# Uses required SOP features, w/o requiring a hard dependency on gosop.
 gosop (<< 1.1.0~),
# Uses required SOP features, w/o requiring a hard dependency on pgpainless.
 pgpainless-cli (<< 1.3.13~),
 libsop-java-java (<< 4.0.7~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildInfo: build information functions
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 libdpkg-perl,
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := \
	-Wall -Wextra \
	-Wno-missing-field-initializers \
	-Wno-nonnull-compare \
	-Wno-unused-parameter \
	# EOL

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = $(WFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(WFLAGS)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS)" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/build-aux/run-script scripts/dpkg-buildflags.pl

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
  testflags += TEST_VERBOSE=1
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  testflags += TEST_PARALLEL=$(NUMJOBS)
endif

dpkg_vendor = \
	$(CURDIR)/build-aux/run-script scripts/dpkg-vendor.pl

DEB_VENDOR = $(shell $(call dpkg_vendor) --query Vendor)

D := $(CURDIR)/debian/tmp

%:
	dh $@ --builddirectory=build-tree

override_dh_auto_configure:
	dh_auto_configure -- \
		$(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--libexecdir=\$${exec_prefix}/lib \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--with-libz \
		--with-liblzma \
		--with-libzstd \
		--with-libbz2 \
		# EOL

execute_after_dh_auto_install:
	# Special-case the lintian profile, as dh cannot rename on install.
	mkdir -p $(D)/usr/share/lintian/profiles/dpkg
	cp debian/dpkg.lintian-profile \
	   $(D)/usr/share/lintian/profiles/dpkg/main.profile

override_dh_auto_test:
	dh_auto_test -- $(testflags)

override_dh_installsystemd:
	dh_installsystemd -a --name=dpkg-db-backup \
	  --no-start --no-stop-on-upgrade

execute_after_dh_installlogrotate:
	dh_installlogrotate --name=alternatives

override_dh_installdocs:
	dh_installdocs -Ndpkg-dev
	dh_installdocs -pdpkg-dev --doc-main-package=dpkg

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

override_dh_bugfiles:
	dh_bugfiles -A

override_dh_compress:
	dh_compress -Xspec/

## dpkg 1.22.21ubuntu1

=== debian/changelog ===
dpkg (1.22.21ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Disable -fstack-clash-protection on armhf since it causes crashes
    - dpkg-buildflags: Add a new feature "framepointer" in the "qa" area.
    - Turn on the use of frame pointers by default on 64bit architectures.
    - Update _FORTIFY_SOURCE documentation.
    - Update Dpkg_BuildFlags test case.
    - Fix debian/rules duplicate invocations of dh_builddeb
    - lib/dpkg/compress.c: clean up override of the default zstd compression
      level
    - dpkg-buildflags: Explicitly turn off hardening flags when requested.
    - Export environment variables DEB_BUILD_OS_RELEASE_ID, DEB_HOST_ARCH,
      DEB_SOURCE, and DEB_VERSION when including buildflags.mk (LP: #2070015)
    - buildflags: document RUSTFLAGS
    - buildflags: Always set RUSTFLAGS
    - tests: avoid failing under DEB_VENDOR != Debian
    - dpkg-buildflags: enable ELF package note metadata
    - buildflags: set origin of env vars for ELF package metadata
    - Export ELF_PACKAGE_METADATA for a build. Picked up by GCC and clang.
      Passing -specs explicitly can be dropped in a follow-up upload.
    - dpkg-buildflags: set RUSTFLAGS to influence the command line flags cargo
      will pass to rustc, and set the flags to include framepointers when the
      framepointer feature of the qa area is enabled.
    - Disable framepointer on ppc64el.
    - Disable framepointer on s390x, leaving only -mbackchain.
    - Add a note about different behaviour of dpkg-buildflags with respect to
      LTO on Ubuntu.
    - dpkg-buildpackage: Construct ELF_PACKAGE_METADATA, and set in the
      environment if not already set.  This setting is picked up by
      GCC and clang, passing a --package-metadata option the the linker.
    - Stop passing --specs for metadata information. It's too fragile
      and only works for GCC. Also introduces a lot of packaging delta.
    - Stop defaulting to -O3 on amd64.
    - dpkg-dev: Still prefer gnupg and gpgv over sq.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 14 Jul 2025 11:45:01 +0200

## dpkg 1.22.21ubuntu2

=== debian/changelog ===
dpkg (1.22.21ubuntu2) questing; urgency=medium

  * Introduce architecture variants (thanks to mwhudson for the rebase)

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 11 Aug 2025 17:40:23 +0200

## dpkg 1.22.21ubuntu3

=== tests/t-conffile-declarative-removal/Makefile ===
TESTS_DEB := pkg-conffile-v1 pkg-conffile-v2 \
             pkg-conffile-owns-filename pkg-conffile-owns-symlink

include ../Test.mk

build-hook:
	ln -sf test-conffile-owned \
	       pkg-conffile-owns-symlink/test-dir/test-conffile-to-be-removed

clean-hook:
	$(RM) pkg-conffile-owns-symlink/test-dir/test-conffile-to-be-removed
	$(RM) pkg-conffile-removal-present.deb

test-case:
	# Conffile marked for removal but present, cannot be installed.
	$(DPKG_BUILD_DEB) --no-check pkg-conffile-removal-present
	! $(DPKG_INSTALL) pkg-conffile-removal-present.deb
	$(call pkg_is_not_installed,pkg-conffile-removal-present)
	$(DPKG_PURGE) pkg-conffile-removal-present

	# Unmodified case, one invocation.
	$(DPKG_INSTALL) pkg-conffile-v1.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"
	$(DPKG_INSTALL) pkg-conffile-v2.deb
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Reset.
	$(DPKG_PURGE) pkg-conffile
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Unmodified case; but force it to happen via two invocations.
	$(DPKG_INSTALL) pkg-conffile-v1.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"
	$(DPKG_UNPACK) pkg-conffile-v2.deb
	# The old conffile is removed during unpack.
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"
	# After configure, the file is still removed.
	$(DPKG_CONFIGURE) pkg-conffile
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Reset.
	$(DPKG_PURGE) pkg-conffile
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Modified; should store .dpkg-old.
	$(DPKG_INSTALL) pkg-conffile-v1.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	echo "modify this" >"$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	$(DPKG_INSTALL) pkg-conffile-v2.deb
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Reset.
	$(DPKG_PURGE) pkg-conffile
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	$(RM) "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Queue a remove on upgrade, and move ownership.
	$(DPKG_INSTALL) pkg-conffile-v1.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	$(DPKG_INSTALL) pkg-conffile-v2.deb
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	$(DPKG_INSTALL) pkg-conffile-owns-filename.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	# Upgrade the package again, should not remove unowned conffile.
	$(DPKG_INSTALL) pkg-conffile-v2.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Reset.
	$(DPKG_PURGE) pkg-conffile
	$(DPKG_PURGE) pkg-conffile-owns
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Queue a remove on upgrade, and move ownership via symlink.
	$(DPKG_INSTALL) pkg-conffile-v1.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	$(DPKG_INSTALL) pkg-conffile-v2.deb
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"
	$(DPKG_INSTALL) pkg-conffile-owns-symlink.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-owned"
	test -L "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	# Upgrade the package again, should not remove unowned conffile.
	$(DPKG_INSTALL) pkg-conffile-v2.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-owned"
	test -L "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"

test-clean:
	$(DPKG_PURGE) pkg-conffile-removal-present
	$(DPKG_PURGE) pkg-conffile-owns
	$(DPKG_PURGE) pkg-conffile
	$(BEROOT) $(RM) -rf "$(DPKG_INSTDIR)/test-dir"

=== tests/t-conffile-replaces-existing/Makefile ===
TESTS_DEB := pkg-conff-original-0 pkg-conff-original-1 pkg-conff-takeover

include ../Test.mk

TEST_CASES += test-two-run-ordered
TEST_CASES += test-one-run-ordered
TEST_CASES += test-two-run-reverse
TEST_CASES += test-one-run-reverse

test-case: $(TEST_CASES)

define VERIFY
$(call pkg_is_installed,pkg-conff-original)
$(call pkg_is_installed,pkg-conff-takeover)
test "`$(DPKG_QUERY) -S /test-conffile`" = "pkg-conff-takeover: /test-conffile"
cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"
endef

test-two-run-ordered:
	# test-two-run-ordered
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(DPKG_INSTALL) pkg-conff-original-1.deb
	$(DPKG_INSTALL) pkg-conff-takeover.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-one-run-ordered:
	# test-one-run-ordered
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(DPKG_INSTALL) pkg-conff-original-1.deb pkg-conff-takeover.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-two-run-reverse:
	# test-two-run-reverse
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(DPKG_INSTALL) pkg-conff-takeover.deb
	$(DPKG_INSTALL) pkg-conff-original-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-one-run-reverse:
	# test-one-run-reverse
	$(DPKG_INSTALL) pkg-conff-original-0.deb
	$(DPKG_INSTALL) pkg-conff-takeover.deb pkg-conff-original-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

=== tests/t-triggers-halt/Makefile ===
TESTS_DEB := pkg-files pkg-depends pkg-remove pkg-trigger

include ../Test.mk

test-case:
	# This is what apt is doing currently. :(
	$(DPKG_INSTALL) pkg-files.deb
	$(DPKG_INSTALL) pkg-depends.deb
	$(DPKG_INSTALL) pkg-remove.deb
	$(DPKG_INSTALL) pkg-trigger.deb
	$(DPKG_REMOVE) --force-depends pkg-remove
	$(DPKG_INSTALL) pkg-files.deb
	$(DPKG_UNPACK) pkg-depends.deb

	$(DPKG) -s pkg-trigger pkg-files pkg-depends

	# Make sure everything is left in the expected state.
	$(call pkg_status_is,pkg-depends,install ok unpacked)
	$(call pkg_status_is,pkg-files,install ok triggers-awaited)
	$(call pkg_status_is,pkg-trigger,install ok triggers-pending)

	# Should fail due to unsatisfied dependencies.
	! $(DPKG_CONFIGURE) pkg-trigger pkg-depends

test-clean:
	-$(DPKG_PURGE) pkg-trigger pkg-depends pkg-files

=== debian/changelog ===
dpkg (1.22.21ubuntu3) questing; urgency=medium

  * scripts/dpkg-gencentrol.pl: fix operator precedence. 

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 25 Aug 2025 16:00:58 +1200

=== scripts/t/mk/debian/changelog ===
source (1:2:3.4-5-6) suite; urgency=low

  * Initial release.

 -- Dpkg Developers <debian-dpkg@lists.debian.org>  Tue, 04 Aug 2015 16:13:50 +0200

=== tests/t-buildinfo/pkg-source/debian/control ===
Source: test-source
Section: test
Priority: extra
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Build-Depends:
 pkg-depender:i386,
 pkg-virtual:i386,
Standards-Version: 3.9.8

Package: pkg-binary-a
Architecture: amd64
Multi-Arch: foreign
Description: test binary a

## dpkg 1.22.21ubuntu3.1

=== tests/t-buildinfo/Makefile ===
OPTS = --admindir=$(CURDIR)/db-buildinfo

test:
	touch test-binary-a_1.0_amd64.deb
	dpkg-source -b pkg-source
	cd pkg-source && DEB_HOST_ARCH=amd64 dpkg-checkbuilddeps $(OPTS)
	cd pkg-source && DEB_HOST_ARCH=amd64 dpkg-genbuildinfo $(OPTS)

test-clean:
	rm -f *.dsc *.deb *.buildinfo
	rm -f *.tar.xz

=== tests/t-conffile-forcemiss/Makefile ===
TESTS_DEB := pkg-conff-forcemiss-0 pkg-conff-forcemiss-1

include ../Test.mk

test-case:
	# Test if we get the new conffile after a missing one.
	$(DPKG_INSTALL) pkg-conff-forcemiss-0.deb
	$(BEROOT) rm "$(DPKG_INSTDIR)/test-conffile"
	$(DPKG_INSTALL) pkg-conff-forcemiss-1.deb
	! test -f "$(DPKG_INSTDIR)/test-conffile"
	$(DPKG_INSTALL) --force-confmiss pkg-conff-forcemiss-1.deb
	cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"
	$(DPKG_PURGE) pkg-conff-forcemiss

test-clean:
	$(DPKG_PURGE) pkg-conff-forcemiss

=== tests/t-conffile-normal/Makefile ===
TESTS_DEB := pkg-conffile

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-conffile.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile"
	$(DPKG_REMOVE) pkg-conffile
	$(DPKG_PURGE) pkg-conffile
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile"
	test ! -d "$(DPKG_INSTDIR)/test-dir"

test-clean:
	$(DPKG_PURGE) pkg-conffile
	$(BEROOT) $(RM) -rf "$(DPKG_INSTDIR)/test-dir"

=== tests/t-conffile-orphan/Makefile ===
TESTS_DEB := pkg-conff-orphan-0 pkg-conff-orphan-1 pkg-conff-takeover

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-conff-orphan-0.deb
	$(DPKG_INSTALL) pkg-conff-orphan-1.deb
	# test if the other package can takeover the orphan conffile
	$(DPKG_INSTALL) pkg-conff-takeover.deb

test-clean:
	$(DPKG_PURGE) pkg-conff-orphan
	$(DPKG_PURGE) pkg-conff-takeover

=== tests/t-conflict-provide-replace-virtual-multiarch/Makefile ===
TESTS_DEB := pkg-virt-i386 pkg-virt-amd64 pkg-real-i386 pkg-real-amd64

include ../Test.mk

test-case:
	$(DPKG) --add-architecture amd64
	$(DPKG) --add-architecture i386
	$(DPKG_INSTALL) pkg-virt-i386.deb
	# Configuring pkg-real:amd64 should not be allowed
	! $(DPKG_INSTALL) pkg-real-amd64.deb
	$(DPKG_INSTALL) pkg-real-i386.deb
	$(DPKG_INSTALL) pkg-virt-amd64.deb
	$(DPKG_INSTALL) pkg-real-i386.deb
	# Purging should not be allowed
	! $(DPKG_PURGE) pkg-virt:i386

test-clean:
	$(DPKG_PURGE) pkg-real:i386
	$(DPKG_PURGE) pkg-real:amd64
	$(DPKG_PURGE) pkg-virt:i386
	$(DPKG_PURGE) pkg-virt:amd64
	$(DPKG) --remove-architecture amd64
	$(DPKG) --remove-architecture i386

=== tests/t-conflicts-replaces/Makefile ===
TESTS_DEB := pkg-a pkg-b

include ../Test.mk

test-case:
	# test if the conflicting package replaces on install
	$(DPKG_INSTALL) pkg-a.deb
	$(DPKG_INSTALL) pkg-b.deb
	$(call pkg_is_installed,pkg-b)
	$(call pkg_is_not_installed,pkg-a)
	-$(DPKG_PURGE) pkg-a pkg-b

	# test if the conflicting package replaces on install
	$(DPKG_INSTALL) pkg-a.deb pkg-b.deb
	$(call pkg_is_installed,pkg-b)
	$(call pkg_is_not_installed,pkg-a)
	-$(DPKG_PURGE) pkg-a pkg-b

	# test if the conflicting package fails on install
	$(DPKG_INSTALL) pkg-b.deb
	! $(DPKG_INSTALL) pkg-a.deb
	$(call pkg_is_not_installed,pkg-a)
	$(call pkg_is_installed,pkg-b)
	-$(DPKG_PURGE) pkg-a pkg-b

	# test if the conflicting package fails on install
	! $(DPKG_INSTALL) pkg-b.deb pkg-a.deb
	$(call pkg_is_not_installed,pkg-a)
	-$(DPKG_PURGE) pkg-a pkg-b

test-clean:
	-$(DPKG_PURGE) pkg-a pkg-b

=== tests/t-dir-extension-check/Makefile ===
TESTS_DEB := pkg-dbg-dir

include ../Test.mk

test-case:
	$(DPKG_INSTALL) -D10 pkg-dbg-dir.deb

test-clean:
	$(DPKG_PURGE) pkg-dbg-dir

=== tests/t-dir-leftover-parents/Makefile ===
TESTS_DEB := pkg-dir-shared pkg-dir-shared-notempty

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-dir-shared.deb
	$(DPKG_INSTALL) pkg-dir-shared-notempty.deb
	$(DPKG_REMOVE) pkg-dir-shared-notempty
	$(DPKG_PURGE) pkg-dir-shared
	$(DPKG_PURGE) pkg-dir-shared-notempty
	test ! -d "$(DPKG_INSTDIR)/test-dir"

test-clean:
	$(DPKG_PURGE) pkg-dir-shared
	$(DPKG_PURGE) pkg-dir-shared-notempty
	$(BEROOT) rm -rf "$(DPKG_INSTDIR)/test-dir"

=== tests/t-disappear/Makefile ===
TESTS_DEB := pkg-normal pkg-disappear-0 pkg-disappear-1

include ../Test.mk

test-case:
	# test disappearing package
	$(DPKG_INSTALL) pkg-disappear-0.deb
	$(DPKG_INSTALL) pkg-disappear-1.deb
	$(DPKG_INSTALL) pkg-normal.deb

test-clean:
	-$(DPKG_PURGE) pkg-disappear
	$(DPKG_PURGE) pkg-normal

=== tests/t-file-replaces-versioned/Makefile ===
TESTS_DEB := pkg-file-original-0 pkg-file-original-1 \
             pkg-file-takeover-0 pkg-file-takeover-1

include ../Test.mk

TEST_CASES += test-two-run-ordered
TEST_CASES += test-one-run-ordered
TEST_CASES += test-two-run-reverse
TEST_CASES += test-one-run-reverse

test-case: $(TEST_CASES)

define VERIFY
$(call pkg_is_installed,pkg-file-original)
$(call pkg_is_installed,pkg-file-takeover)
test "`$(DPKG_QUERY) -S /test-file`" = "pkg-file-takeover: /test-file"
cmp ref-file "$(DPKG_INSTDIR)/test-file"
endef

test-two-run-ordered:
	# test-two-run-ordered
	$(DPKG_INSTALL) pkg-file-original-0.deb pkg-file-takeover-0.deb
	$(DPKG_INSTALL) pkg-file-original-1.deb
	$(DPKG_INSTALL) pkg-file-takeover-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

test-one-run-ordered:
	# test-one-run-ordered
	$(DPKG_INSTALL) pkg-file-original-0.deb pkg-file-takeover-0.deb
	$(DPKG_INSTALL) pkg-file-original-1.deb pkg-file-takeover-1.deb
	$(DPKG_CONFIGURE) -a
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

test-two-run-reverse:
	# test-two-run-reverse
	$(DPKG_INSTALL) pkg-file-original-0.deb pkg-file-takeover-0.deb
	$(DPKG_INSTALL) pkg-file-takeover-1.deb
	$(DPKG_INSTALL) pkg-file-original-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

test-one-run-reverse:
	# test-one-run-reverse
	$(DPKG_INSTALL) pkg-file-original-0.deb pkg-file-takeover-0.deb
	$(DPKG_INSTALL) pkg-file-takeover-1.deb pkg-file-original-1.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

test-clean:
	$(DPKG_PURGE) pkg-file-original pkg-file-takeover

=== tests/t-normal/Makefile ===
TESTS_DEB := pkg-normal

include ../Test.mk

test-case:
	# test normal working packages
	$(DPKG_INSTALL) pkg-normal.deb
	$(call pkg_is_installed,pkg-normal)

test-clean:
	$(DPKG_PURGE) pkg-normal

=== tests/t-option-recursive/Makefile ===
TESTS_DEB := dir-a/pkg-a dir-b/dir-bb/pkg-b pkg-c

include ../Test.mk

test-case:
	# Try recursive directory unpacking of packages
	$(DPKG_INSTALL) -R .
	$(call pkg_is_unpacked,pkg-a)
	$(call pkg_is_unpacked,pkg-b)
	$(call pkg_is_unpacked,pkg-c)
	
	$(DPKG_PURGE) pkg-a
	$(DPKG_PURGE) pkg-b
	$(DPKG_PURGE) pkg-c
	
	# Try recursive directory installation of packages
	$(DPKG_INSTALL) -R .
	$(call pkg_is_installed,pkg-a)
	$(call pkg_is_installed,pkg-b)
	$(call pkg_is_installed,pkg-c)

test-clean:
	$(DPKG_PURGE) pkg-a
	$(DPKG_PURGE) pkg-b
	$(DPKG_PURGE) pkg-c

=== debian/changelog ===
dpkg (1.22.21ubuntu3.1) questing; urgency=medium

  * Copy across the architecture variant (LP: #2128606)

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 16 Oct 2025 18:46:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: dpkg
 Section: admin
 Priority: required
-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
 Uploaders: Guillem Jover <guillem@debian.org>
 Homepage: https://wiki.debian.org/Teams/Dpkg
 Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
@@ -127,14 +128,15 @@
  patch (>= 2.7),
  make,
  binutils,
+ lto-disabled-list,
 Recommends:
  build-essential,
  gcc | c-compiler,
  fakeroot,
 # OpenPGP implementations providing full support.
- sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq | gnupg,
+ gnupg | sq | sqop | rsop | gosop | pgpainless-cli | gpg-sq,
 # OpenPGP implementations providing at least verification-only support.
- sqv | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq | gpgv,
+ gpgv | sqv | sqopv | rsopv | sopv | gosop | pgpainless-cli | gpgv-sq,
 # Used by dpkg-mergechangelogs.
  libalgorithm-merge-perl,
 Suggests:

=== scripts/t/dpkg_buildtree/src-rrr-binary-targets/debian/control ===
Source: source-rrr-binary-targets
Rules-Requires-Root: binary-targets

Package: binary
Architecture: all

=== scripts/t/dpkg_buildtree/src-rrr-dpkg-target-binary/debian/control ===
Source: source-rrr-dpkg-target-binary
Rules-Requires-Root: dpkg/target/binary

Package: binary
Architecture: all

=== scripts/t/dpkg_buildtree/src-rrr-dpkg-unknown-keyword/debian/control ===
Source: source-rrr-dpkg-unknown-keyword
Rules-Requires-Root: dpkg/unknown-keyword

Package: binary
Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -86,3 +86,9 @@
 
 override_dh_compress:
 	dh_compress -Xspec/
+
+override_dh_builddeb:
+	# Make debootstrap life easier on non-Debian based systems by
+	# compressing dpkg.deb with xz instead of zstd.
+	dh_builddeb -pdpkg -- -Zxz
+	dh_builddeb -Ndpkg
